<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<!--
IGAC proyecto SNC

@author  pedro.garcia
@description  página donde se muestra la información con la que se va a generar la orden de práctica
  para trámites de avalúos
@cu  CU-SA-AC-009

-->

<!--N:
    no sirvió actualizar solo el componente de edición de filas, por lo que hubo que actualiza toda la tabla -->

<h:panelGrid
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:p="http://primefaces.org/ui"
    xmlns:h="http://java.sun.com/jsf/html"
    xmlns:f="http://java.sun.com/jsf/core"
    width="100%"
    id="infoOrdenPracticaPG">


    <h:form id="infoOrdenPracticaForm">

        <p:fieldset>

            <p:messages id="infoOPMsgs" showDetail="false" />

            <p:accordionPanel id="infoEncabezadoOrdenPracticaAP">
                <p:tab 
                    title="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Información de la orden de práctica"
                    titletip="De click aquí para expandir on retraer el panel de información">

                    <h:panelGrid columns="4" width="100%" cellspacing="5" columnClasses="col25p, col25p, col25p, col25p">
                        <h:outputLabel value="Número orden de práctica: " styleClass="outputLabelStyle" />
                        <h:outputText value="#{generacionOrdenPractica.ordenPracticaSeleccionada.numero}"
                                      styleClass="outputTextStyle"/>

                        <h:outputLabel value="Fecha orden de práctica: " styleClass="outputLabelStyle" />
                        <h:outputText id="fechaOPInput"
                                      value="#{generacionOrdenPractica.ordenPracticaSeleccionada.fecha}"
                                      styleClass="outputTextStyle">
                            <f:convertDateTime pattern="#{general.formatoFechaUsuario2}"
                                               timeZone="#{general.zonaGMT}" />
                        </h:outputText>
                    </h:panelGrid>

                    <p:separator />

                    <h:panelGrid columns="4" width="100%" cellspacing="7" columnClasses="col25p, col25p, col25p, col25p">

                        <h:outputLabel value="Territorial: " styleClass="outputLabelStyle" />
                        <h:outputText  value="#{generacionOrdenPractica.territorialUsuario.nombre}" styleClass="outputTextStyle"/>

                        <h:outputLabel value="Municipio sede territorial: " styleClass="outputLabelStyle" />
                        <h:outputText  value="FIXME!!!!!!!" styleClass="outputTextStyle"/>

                    </h:panelGrid>

                    <p:separator />

                    <h:panelGrid columns="4" width="100%" cellspacing="7" columnClasses="col25p, col25p, col25p, col25p">
                        <h:outputLabel value="Tipo solicitante: " styleClass="outputLabelStyle" />
                        <h:outputText
                            value="#{generacionOrdenPractica.selectedAvaluosForOP[0].solicitanteTramite.tipoPersona}"
                            styleClass="outputTextStyle" />

                        <h:outputLabel value="Solicitante: " styleClass="outputLabelStyle" />
                        <h:outputText
                            value="#{generacionOrdenPractica.selectedAvaluosForOP[0].solicitanteTramite.nombreCompleto}"
                            styleClass="outputTextStyle" />

                        <h:outputLabel value="Representante legal: " styleClass="outputLabelStyle" />
                        <h:outputText
                            value="#{generacionOrdenPractica.selectedAvaluosForOP[0].representanteLegalSolicitanteTramite.nombreCompleto}"
                            styleClass="outputTextStyle" />


                        <h:outputLabel value="Cargo representante legal: " styleClass="outputLabelStyle" />
                        <h:outputText
                            value="fixme: no hay"
                            styleClass="outputTextStyle" />

                    </h:panelGrid>

                    <h:panelGrid rendered="#{generacionOrdenPractica.mostrarDatosContrato}"
                                 columns="4" width="100%" cellspacing="7" columnClasses="col25p, col25p, col25p, col25p">
                        <h:outputLabel value="Contrato interadministrativo: " styleClass="outputLabelStyle" />
                        <h:outputText value="#{generacionOrdenPractica.contratoInteradminHeader.numero}" />
                        <h:outputText value="&nbsp;" />
                        <h:outputText value="&nbsp;" />

                        <h:outputLabel value="Interventor contrato interadministrativo: "
                                       styleClass="outputLabelStyle" />
                        <h:outputText
                            value="#{generacionOrdenPractica.contratoInteradminHeader.interventorNombre}"
                            styleClass="outputTextStyle" />

                        <h:outputLabel value="Correo electrónico interventor contrato interadministrativo: "
                                       styleClass="outputLabelStyle" />
                        <h:outputText  value="#{generacionOrdenPractica.contratoInteradminHeader.interventor.correoElectronico}"
                                       styleClass="outputTextStyle" />

                    </h:panelGrid>

                </p:tab>
            </p:accordionPanel>

            <p:spacer height="5" width="0" />

            <p:dataTable
                value="#{generacionOrdenPractica.avaluadoresTramitesOP}"
                var="avaluadorAsignado"
                rowKey="#{avaluadorAsignado.id}"
                paginator="true" rows="5"
                paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink}
                {PageLinks} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                rowsPerPageTemplate="5,10,15" paginatorPosition="bottom"
                emptyMessage="No hay avaluadores asignados relacionados a la orden de práctica.">
                <f:facet name="header">
                    <h:outputText value="Avaluadores asignados a los trámites" />
                </f:facet>

                <p:column headerText="Nombre avaluador">
                    <h:outputText value="#{avaluadorAsignado.nombreCompleto}" />
                </p:column>

                <p:column headerText="Tipo contrato">
                    <h:outputText value="#{avaluadorAsignado.tipoVinculacion}" />
                </p:column>

                <p:column headerText="Número contrato">
                    <h:outputText
                        value="#{avaluadorAsignado.contratoActivo.contratoNumero}" />
                </p:column>

                <p:column headerText="Año contrato">
                    <h:outputText value="#{avaluadorAsignado.contratoActivo.anio}" />
                </p:column>

                <p:column headerText="Email avaluador">
                    <h:outputText value="#{avaluadorAsignado.correoElectronico}" />
                </p:column>

                <p:column headerText="Email interventor del avaluador">
                    <h:outputText
                        value="#{avaluadorAsignado.interventor.correoElectronico}" />
                </p:column>

                <p:column headerText="Celular avaluador">
                    <h:outputText value="#{avaluadorAsignado.celular}" />
                </p:column>

            </p:dataTable>


            <p:spacer height="20" width="0" />

            <p:dataTable
                id="avaluosOPDT"
                editable="true"
                value="#{generacionOrdenPractica.selectedAvaluosForOP}"
                var="avaluoOP"
                rowKey="#{avaluoOP.id}"
                paginator="true" rows="5"
                paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink}
                {PageLinks} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                rowsPerPageTemplate="5,10,15" paginatorPosition="bottom"
                emptyMessage="No hay trámites relacionados a la orden de práctica.">

                <f:facet name="header">
                    <h:outputText value="Trámites incluidos en la orden de práctica" />
                </f:facet>
                <p:ajax event="rowEdit" listener="#{generacionOrdenPractica.editarAvaluoOPListener}"
                        update=":infoOrdenPracticaForm:infoOPMsgs, :infoOrdenPracticaForm:avaluosOPDT" />

                <p:column headerText="Información predial">
                    <p:commandButton
                        title="Información de los predios del avalúo"
                        icon="ui-icon-home"
                        action="#{consultaInformacionPredial.cargarInformacionPredial}"
                        update=":prediosAvaluoForm"
                        onstart="statusDialog2.show();"
                        oncomplete="statusDialog2.hide();
                        handleCompleteSIC(xhr, status, args, infoPredialWV, true);">
                        <f:setPropertyActionListener value="#{avaluoOP}"
                                                     target="#{consultaInformacionPredial.avaluoSeleccionado}" />
                    </p:commandButton>
                </p:column>

                <p:column headerText="Sec. radicado">
                    <h:outputText value="#{avaluoOP.secRadicado}" />
                </p:column>

                <p:column headerText="Departamento">
                    <p:commandLink
                        value="#{avaluoOP.avaluoPredios[0].departamento.nombre}"
                        rendered="#{avaluoOP.tienePrediosEnDiferentesDeptos}"
                        styleClass="commandLinkStyle"
                        action="#{consultarDptoMunpioAvaluo.cargarDeptosMunisAvaluo}"
                        update=":consultarDepartamentosMunicipioForm"
                        onstart="statusDialog2.show();"
                        oncomplete="statusDialog2.hide();
                        handleCompleteSIC(xhr, status, args, infoDeptosMunisWV, true);">
                        <f:setPropertyActionListener value="#{avaluoOP}"
                                                     target="#{consultarDptoMunpioAvaluo.avaluoSeleccionado}" />
                    </p:commandLink>

                    <h:outputText rendered="#{!avaluoOP.tienePrediosEnDiferentesDeptos}"
                                  value="#{avaluoOP.avaluoPredios[0].departamento.codigo} - #{avaluoOP.avaluoPredios[0].departamento.nombre}" />

                </p:column>

                <p:column headerText="Municipio">
                    <p:commandLink value="#{avaluoOP.avaluoPredios[0].municipio.nombre}"
                                   rendered="#{avaluoOP.tienePrediosEnDiferentesMunicipios}"
                                   styleClass="commandLinkStyle"
                                   action="#{consultarDptoMunpioAvaluo.cargarDeptosMunisAvaluo}"
                                   update=":consultarDepartamentosMunicipioForm"
                                   onstart="statusDialog2.show();"
                                   oncomplete="statusDialog2.hide();
                                   handleCompleteSIC(xhr, status, args, infoDeptosMunisWV, true);">
                        <f:setPropertyActionListener value="#{avaluoOP}"
                                                     target="#{consultarDptoMunpioAvaluo.avaluoSeleccionado}" />
                    </p:commandLink>

                    <h:outputText
                        rendered="#{!avaluoOP.tienePrediosEnDiferentesMunicipios}"
                        value="#{avaluoOP.avaluoPredios[0].municipio.codigo} - #{avaluoOP.avaluoPredios[0].municipio.nombre}" />

                </p:column>

                <p:column headerText="Días de entrega">
                    <p:cellEditor>
                        <f:facet name="output">
                            <h:outputText value="#{avaluoOP.plazoEjecucion}" />
                        </f:facet>
                        <f:facet name="input">
                            <p:inputText 
                                value="#{avaluoOP.plazoEjecucion}"
                                label="Plazo de entrega">
                                <f:validateLongRange minimum="0" maximum="365" />
                            </p:inputText>
                        </f:facet>
                    </p:cellEditor>
                </p:column>

                <p:column headerText="Modificar días entrega"
                          id="modificarDiasEntregaColumn" 
                          rendered="#{generacionOrdenPractica.creandoOModificandoOP}">
                    <p:rowEditor id="modificarDiasEntregaEditor" />
                </p:column>

            </p:dataTable>


            <p:spacer height="20" width="0" />

            <h:panelGrid columns="1" width="100%" id="observacionesOPPG" >
                <h:outputLabel value="Observaciones adicionales: " styleClass="outputLabelStyle" />
                <h:inputTextarea 
                    cols="150" rows="3" value="#{generacionOrdenPractica.ordenPracticaSeleccionada.observaciones}"
                    disabled="#{!generacionOrdenPractica.creandoOModificandoOP}">
                    <f:validateLength maximum="2000" />
                </h:inputTextarea>
            </h:panelGrid>

            <p:outputPanel layout="block" style="text-align: left">
                <h:panelGrid columns="6" id="infoOrdenPracticaBtns">
                    <p:commandButton
                        id="aceptarGenerarOPBtn"
                        disabled="#{generacionOrdenPractica.ordenPracticaGenerada}"
                        value="Aceptar" icon="ui-icon-disk"
                        onstart="statusDialog2.show();"
                        oncomplete="statusDialog2.hide();"
                        action="#{generacionOrdenPractica.generarOrdenPractica}"
                        update=":infoOrdenPracticaForm:infoOPMsgs,
                        :infoOrdenPracticaForm:observacionesOPPG,
                        :infoOrdenPracticaForm:infoOrdenPracticaBtns,
                        :infoOrdenPracticaForm:avaluosOPDT"/>

                    <p:commandButton value="Enviar" icon="ui-icon-mail-closed"
                                     disabled="#{!generacionOrdenPractica.ordenPracticaGenerada}"
                                     action="#{generacionOrdenPractica.enviarOrdenPractica}"
                                     update=":infoOrdenPracticaForm:infoOPMsgs, 
                                     :amindOrdenPracticaTV"
                                     onstart="statusDialog2.show();"
                                     oncomplete="statusDialog2.hide(); "/>

                    <p:commandButton value="Vista previa" icon="ui-icon-print"
                                     action="#{generacionOrdenPractica.cargarDocumentoOrdenPractica}"
                                     update=":amindOrdenPracticaTV:enviarOrdenesPracticaTAB"
                                     onstart="statusDialog2.show();"
                                     oncomplete="statusDialog2.hide(); 
                                     handleCompleteSIC(xhr, status, args, ordenPracticaWV, true);"
                                     disabled="#{!generacionOrdenPractica.ordenPracticaGenerada}"/>

                    <p:commandButton
                        value="Modificar" icon="ui-icon-pencil"
                        disabled="#{generacionOrdenPractica.ordenPracticaEnviada || !generacionOrdenPractica.ordenPracticaGenerada}"
                        action="#{generacionOrdenPractica.modificarOrdenPracticaInit}"
                        update=":infoOrdenPracticaPG"
                        />

                    <p:commandButton
                        value="Cancelar" icon="ui-icon-cancel"
                        action="#{generacionOrdenPractica.cancelarGeneracionOP}"
                        onclick="hide();"/>

                </h:panelGrid>

                <p:blockUI block=":infoOrdenPracticaPG" trigger="aceptarGenerarOPBtn">
                    Generando la orden de práctica<br />
                    <p:graphicImage value="/images/loading.gif" />
                </p:blockUI>

            </p:outputPanel>

        </p:fieldset>

    </h:form>

</h:panelGrid>